/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE PACKAGE
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#ifdef PACKAGE_NAME
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE_NAME
#else
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE
#endif
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int beep_flag;	/**< @brief Beep at the end of the resolution (default=on).  */
  const char *beep_help; /**< @brief Beep at the end of the resolution help description.  */
  int continue_arg;	/**< @brief Continue resolution at position N.  */
  char * continue_orig;	/**< @brief Continue resolution at position N original value given at command line.  */
  const char *continue_help; /**< @brief Continue resolution at position N help description.  */
  int explore_flag;	/**< @brief Explore moves (default=on).  */
  const char *explore_help; /**< @brief Explore moves help description.  */
  int verbose_flag;	/**< @brief Show progress on standard output (default=off).  */
  const char *verbose_help; /**< @brief Show progress on standard output help description.  */
  char * watch_arg;	/**< @brief Watch occupied squares. See documentation.  */
  char * watch_orig;	/**< @brief Watch occupied squares. See documentation original value given at command line.  */
  const char *watch_help; /**< @brief Watch occupied squares. See documentation help description.  */
  char * language_arg;	/**< @brief Language of output.  CHAR is `d' or `g' for Deutsch, `e' for English or `f' for Francais.  */
  char * language_orig;	/**< @brief Language of output.  CHAR is `d' or `g' for Deutsch, `e' for English or `f' for Francais original value given at command line.  */
  const char *language_help; /**< @brief Language of output.  CHAR is `d' or `g' for Deutsch, `e' for English or `f' for Francais help description.  */
  int moves_arg;	/**< @brief Find all solutions in N single moves.  */
  char * moves_orig;	/**< @brief Find all solutions in N single moves original value given at command line.  */
  const char *moves_help; /**< @brief Find all solutions in N single moves help description.  */
  char * output_arg;	/**< @brief Output informations to FILE.  */
  char * output_orig;	/**< @brief Output informations to FILE original value given at command line.  */
  const char *output_help; /**< @brief Output informations to FILE help description.  */
  int position_arg;	/**< @brief Show positions.  LEVEL is 1 for positions, 2 for positions and moves order, 3 for more.  Without LEVEL, 1 is assumed..  */
  char * position_orig;	/**< @brief Show positions.  LEVEL is 1 for positions, 2 for positions and moves order, 3 for more.  Without LEVEL, 1 is assumed. original value given at command line.  */
  const char *position_help; /**< @brief Show positions.  LEVEL is 1 for positions, 2 for positions and moves order, 3 for more.  Without LEVEL, 1 is assumed. help description.  */
  int stop_arg;	/**< @brief Stop resolution after N solutions.  */
  char * stop_orig;	/**< @brief Stop resolution after N solutions original value given at command line.  */
  const char *stop_help; /**< @brief Stop resolution after N solutions help description.  */
  int hash_size_arg;	/**< @brief Use N Mb for hash-table size (default='6').  */
  char * hash_size_orig;	/**< @brief Use N Mb for hash-table size original value given at command line.  */
  const char *hash_size_help; /**< @brief Use N Mb for hash-table size help description.  */
  int visual_flag;	/**< @brief Visual mode (default=off).  */
  const char *visual_help; /**< @brief Visual mode help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int beep_given ;	/**< @brief Whether beep was given.  */
  unsigned int continue_given ;	/**< @brief Whether continue was given.  */
  unsigned int explore_given ;	/**< @brief Whether explore was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */
  unsigned int watch_given ;	/**< @brief Whether watch was given.  */
  unsigned int language_given ;	/**< @brief Whether language was given.  */
  unsigned int moves_given ;	/**< @brief Whether moves was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int position_given ;	/**< @brief Whether position was given.  */
  unsigned int stop_given ;	/**< @brief Whether stop was given.  */
  unsigned int hash_size_given ;	/**< @brief Whether hash-size was given.  */
  unsigned int visual_given ;	/**< @brief Whether visual was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
