/*
 * expltype.h --- Data structure for move exploration.
 *
 * Copyright (c) 2000, 2001, 2015 by Pascal Wassong All Rights Reserved.
 *
 * This file is part of Natch.
 *
 * Natch is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Natch is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef	EXPLTYPE_H
#define	EXPLTYPE_H

#include	"types.h"

typedef struct
{
    piece_index_t	board[ 8 * 16 ];
    square_t		pieces_squares[ NOMBRE_MAXIMUM_DE_PIECES ];
    piece_type_t	pieces_types  [ NOMBRE_MAXIMUM_DE_PIECES ];

    piece_t		pieces[ NOMBRE_MAXIMUM_DE_PIECES ];

    unsigned int	nb_moving_pieces ;

    unsigned int	white_moves ;
    unsigned int	black_moves ;

    unsigned int	white_spare_moves ;
    unsigned int	black_spare_moves ;

    unsigned int	white_pieces_to_capture ;
    unsigned int	black_pieces_to_capture ;

    distance_tables_t	distances;

    /* Limit in single moves for the -k option */
    unsigned int	number_of_moves_limit ;
} exploration_t ;

#ifndef EXTERN_EXPLORATION
#define EXTERN_EXPLORATION extern
#endif

EXTERN_EXPLORATION	piece_t*	White_king ;
EXTERN_EXPLORATION	piece_t*	Black_king ;

#endif /* EXPLTYPE_H */
