/*
 * immobile_kings_in_check.c --- check if an immobile king (or have castled as
 *                               its sole move), is in check during the
 *                               trajectories of other pieces.
 *
 * Copyright (c) 2015 by Pascal Wassong All Rights Reserved.
 *
 * This file is part of Natch.
 *
 * Natch is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Natch is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef IMMOBILE_KINGS_IN_CHECK_H
#define IMMOBILE_KINGS_IN_CHECK_H

#include "types.h"
#include "pcpj.h"

bool_t
are_immobile_kings_checked(
    const piece_t* white_king,
    const piece_t* black_king,
    bool_t* must_white_king_switchback,
    bool_t* must_black_king_switchback);

#endif /* IMMOBILE_KINGS_IN_CHECK_H */
